from tkinter import *
from tkinter.font import *
import os
##Création d'une fenetre en plein écran avec pour titre "Projet de NSI" et un arrière-plan vert
fenetre=Tk()
fenetre.title("Projet de NSI")
fenetre.configure(bg='#39AD6B')
fenetre.attributes('-fullscreen',True)
##On ajoute une image en arrière plan qui ne sera montrée qu'au début, lorsque l'utilisateur n'a encore rien séléctionné dans le menu, ainsi que le texte "Bienvenue au pays du chiffrement"
fonte=Font(family="Nimbus Roman",size=80,weight="bold",slant="italic")
## Création d'une fonte pour le texte "Bienvenue au pays du chiffrement"
canvasJC=Canvas(fenetre,width=709,height=709,bg='#39AD6B',highlightthickness=0)
bg=PhotoImage(file="J-C5.gif")
canvasJC.create_image(0,0,image=bg,anchor="nw")
LBienvenue=Label(fenetre,text="Bienvenue",bg='#39AD6B')
LBienvenue.configure(font=fonte)
LBienvenue.pack(side=LEFT,ipadx=110)
LPays=Label(fenetre,text="au pays",bg='#39AD6B')
LPays.configure(font=fonte)
LPays.pack(side=RIGHT,ipadx=110)
LChiffr=Label(fenetre,text="du chiffrement",bg='#39AD6B')
LChiffr.configure(font=fonte)
LChiffr.pack(side=BOTTOM,ipady=140)
canvasJC.pack(side=TOP)
##Création des labels et des zones de texte permettant d'afficher le texte à transformer, la clef (quand il y en a une) et les instructions telles que "Entrez votre texte à chiffrer avec..."
##On crée également les textes d'informations
Lhistorique=Label(fenetre, text = "En cryptographie, le code César est une méthode de chiffrement très simple qui fut utilisée par Jules César dans ses correspondances secrètes (ce qui explique le nom « code César »). Seul, il n'offre aucune sécurité de communication, à cause du très faible nombre de clefs, ce qui permet d'essayer systématiquement celles-ci quand la méthode de chiffrement est connue, mais aussi parce que, comme tout encodage par substitution monoalphabétique, il peut être très rapidement « cassé » par analyse de fréquences : en français, on peut facilement repérer le e. Mais il a pu être utilisé comme élément d'une méthode plus complexe, comme le chiffre de Vigenère, que l'on nomme ici code des rois de France.\n \n Le code Morse est un code inventé en 1832 permettant de transmettre un texte à l'aide d'impulsions courtes et longues, qu'elles soient produites par des signes, une lumière, un son ou un geste. Ce code tient son nom de Samuel Morse, mais l'inventeur est probablement son assistant, Alfred Vail. Il a servi pour les communications télégraphiques et  est le précurseur des communications numériques. \n \n Le braille est un système d'écriture tactile à points saillants, à l'usage des personnes aveugles ou fortement malvoyantes. Le système porte le nom de son inventeur, le français Louis Braille qui avait perdu la vue à la suite d'un accident.",font=("Courrier",20),bg='#39AD6B',wraplength=1500)
avocat=Label(fenetre, text = "Le code avocat (a vaut k) est un code permettant de décaler l'alphabet de 16 vers la droite, donc de transformer le a en k. Pour essayer ce code, saisissez un décalage de 16.",font=("Courrier",20),bg='#fae5d3',wraplength=350,relief=RAISED)
LEntrTxtCesar=Label(fenetre, text = "Entrez votre texte à coder avec le code César :",font=("Courrier",20),bg='#39AD6B')
EntrTxtCesar=Text(width=70,height=10,font=("Courrier",20))
LEntrDec=Label(fenetre, text = "Choisissez un décalage :",font=("Courrier",20),bg='#39AD6B')
EntrDec=Entry(width=70,font=("Courrier",20))
txtch=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
m_a=Entry(bg="yellow",font=("Courrier",20),width=35)
LEntrTxtCesar_dec=Label(fenetre,text="Entrez votre texte à décoder avec le code César :", font=("Courrier",20),bg='#39AD6B')
EntrTxtCesar_dec=Text(width=70,height=10,font=("Courrier",20))
EntrDec_dec=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LRien=Label(fenetre,text="Si aucune des propositions n'est pertinente, cliquez sur le bouton Montrer ci-dessous.", font=("Courrier",20),bg='#39AD6B')
LEntrMorse=Label(fenetre,text="Entrez votre texte à coder en morse :",font=("Courrier",20),bg='#39AD6B')
EntrMorse=Text(width=70,height=10,font=("Courrier",20))
EntrMorseDec=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LEntrMorse_dec=Label(fenetre,text="Entrez votre texte à décoder grâce au morse :",font=("Courrier",20),bg='#39AD6B')
EntrMorse_dec=Text(width=70,height=10,font=("Courrier",20))
EntrMorseDec_dec=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LEntrCdeRois=Label(fenetre,text="Entrez votre texte à coder avec le code des rois de France :",font=("Courrier",20),bg='#39AD6B')
EntrCdeRois=Text(width=70,height=10,font=("Courrier",20))
LEntrClef=Label(fenetre, text = "Choisissez une clef (il doit s'agir d'une ou plusieurs lettres) :",font=("Courrier",20),bg='#39AD6B')
EntrClef=Entry(width=70,font=("Courrier",20))
EntrCdeRoisDec=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LEntrCdeRois_dec=Label(fenetre,text="Entrez votre texte à décoder avec le code des rois de France :",font=("Courrier",20),bg='#39AD6B')
EntrCdeRois_dec=Text(width=70,height=10,font=("Courrier",20))
LEntrClef_dec=Label(fenetre, text = "Saisissez votre clef (il doit s'agir d'une ou plusieurs lettres) :",font=("Courrier",20),bg='#39AD6B')
EntrClef_dec=Entry(width=70,font=("Courrier",20))
EntrCdeRoisDec_dec=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LEntrBraille=Label(fenetre,text="Entrez votre texte à coder en braille :",font=("Courrier",20),bg='#39AD6B')
EntrBraille=Text(width=70,height=10,font=("Courrier",20))
EntrBrailleCode=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LEntrBraille_dec=Label(fenetre,text="Entrez votre texte à décoder en braille :",font=("Courrier",20),bg='#39AD6B')
EntrBraille_dec=Text(width=70,height=10,font=("Courrier",20))
EntrBrailleCode_dec=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LEntrBip=Label(fenetre,text="Entrez votre texte (en morse) à faire biper :",font=("Courrier",20),bg='#39AD6B')
EntrBip=Text(width=70,height=10,font=("Courrier",20))
LEntrLapin=Label(fenetre,text="Entrez votre texte à coder en code lapin :",font=("Courrier",20),bg='#39AD6B')
EntrLapin=Text(width=70,height=10,font=("Courrier",20))
EntrLapinCode=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
LEntrLapin_dec=Label(fenetre,text="Entrez votre texte à décoder en code lapin :",font=("Courrier",20),bg='#39AD6B')
EntrLapin_dec=Text(width=70,height=10,font=("Courrier",20))
EntrLapinCode_dec=Text(bg="#00c3ff",width=70,height=10,font=("Courrier",20))
#La fonction décalage a pour rôle de décaler l'alphabet latin vers la droite, x fois. Cette fonction sera utilisée pour le code César et pour le code des rois de France
def decalage(x):
    alph = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    alph2 = alph
    x = x%26#Modulo si le décalage choisi est inférieur à 0 ou supérieur à 26
    for i in range(x):
        alph2.insert(0,alph2.pop())#On décale la liste en supprimant son dernier élement et en placant celui-ci en première place x fois.
    return alph2
#La fonction accents_majs nous permet de remplacer toutes les lettres accentuées par leur équivalent sans accent et de transformer toutes les majuscules en minuscules.
def accents_majs(x):
    a = 0
    for i in x:
        if i.isupper():
            x[a] = i.lower()
            i = i.lower()#On remplace donc toutes les majuscules par des minuscules.
        #On va maintenant remplacer toutes les lettres accentuées par leur équivalent non-accentué.
        if i=="é" or i=="è" or i=="ê" or i=="ë":
            x[a] = "e"
        elif i=="à" or i=="â" or i=="ä":
            x[a] = "a"
        elif i=="ô" or i=="ö":
            x[a] = "o"
        elif i=="î" or i=="ï":
            x[a] = "i"
        elif i=="ç" or i=="Ç":
            x[a] = "c"
        elif i=="ù" or i=="û" or i=="ü":
            x[a] = "u"
        elif i=="œ":
            x[a] = "o"
            x.insert(a+1,"e")
        elif i=="ÿ":
            x[a] = "y"
        a+=1
    return x

#Programme de chiffrement et déchiffrement du code César

#La fonction chiffrage a pour rôle de remplacer toutes les lettres d'un texte par leur équivalent en index dans un alphabet décalé de x fois.
def chiffrage_cesar():
    x=int(EntrDec.get())
    ##Ici, on récupère le décalage entré par l'utilisateur.
    alph2 = decalage(x)
    texte=EntrTxtCesar.get("1.0","end")
    #Décalage du texte : il faut d'abord le convertir en liste pour mieux le manipuler
    texte=list(texte)
    texte=accents_majs(texte)
    #Chiffrage du texte
    alph = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    y = list(texte)
    b = 0
    y= accents_majs(y)
    for i in y:
        if y[b] in alph:
             j = alph.index(y[b])
             y[b] = alph2[j]
             #On remplace chaque lettre par son équivalent dans l'alphabet décalé grâce à son index.
        b+=1
    y = "".join(y)
    return y
#Affichage de l'alphabet décalé
def affichAlphach():
    x=int(EntrDec.get())
    alphabet_chiffre=decalage(x)
    m_a.insert(0,alphabet_chiffre)
    m_a.pack()
##Création du bouton permettant d'afficher la zone de texte montrant l'alphabet décalé
montr_alphach=Button(fenetre,text="Montrer l'alphabet chiffré",command=affichAlphach,font=("Courrier",20),bg="#2c66e9")
##Affichage du texte chiffré dans une zone de texte
def affichTxtch():
    texte_chiffre=chiffrage_cesar()
    txtch.pack()
    txtch.delete(1.0,END)
    txtch.insert("1.0",texte_chiffre)
    montr_alphach.pack()
##Création du bouton permettant à l'utilisateur d'obtenir son texte chiffré
bchiffr=Button(fenetre, text="Chiffrer",command=affichTxtch,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le chiffrage du code César et de cacher les éléments inutiles
def codageCesar():
    LEntrTxtCesar.pack()
    EntrTxtCesar.pack()
    EntrTxtCesar.delete(1.0,END)
    LEntrDec.pack()
    EntrDec.pack()
    EntrDec.delete(0,END)
    EntrDec_dec.pack_forget()
    txtch.pack_forget()
    bchiffr.pack()
    m_a.delete(0,END)
    m_a.pack_forget()
    montr_alphach.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place(x = 10, y = 60)
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()
#La fonction decryptage a pour rôle de remplacer, en connaissant le décalage y, les lettres d'un texte chiffré par leur équivalent en index dans un alphabet normal.
#On fait la même chose que le chiffrage du code César mais dans l'autre sens.
def decryptage(x,y):
    alph = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    alph2 = decalage(y)
    x = list(x)
    a = 0
    for i in x:
        if i in alph:
            j = alph2.index(i)
            x[a] = alph[j]
        a+=1
    x= "".join(x)
    return x
###La fonction pourcentages permet de déterminer les décalages les plus probables pour rendre le texte chiffré en texte normal.
#Il va donc inspecter la récurrence des lettres et les faire correspondre aux lettres les plus fréquentes dans la langue française.
#Il rend ensuite une option principale et trois autres au minimum.
def pourcentages():
    alph = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    x=EntrTxtCesar_dec.get("1.0","end")
    x = list(x)
    app_max = [0,""]
    opt =  [[0,""],[0,""],[0,""]]
    db = []
    app = 0
    nombre_lettres_total = 0
    l_ind = [0, 8, 18]
    pl = []
    y = []
    place = 0
    #On commence par calculer la récurrence de toutes les lettres de l'alphabet dans le texte donné. On place dans la liste app_max la lettre récurrente et son nombre exact d'apparence.
    #Dans la liste opt, on place les mêmes informations mes pour les trois autres lettres les plus récurrentes.
    #S'il y a une cinquième option aussi récurrente que la quatrième, on place les informations de celle_ci dans la liste db.
    for i in alph:
        opt = tri(opt)
        app = x.count(i)
        nombre_lettres_total += app
        if app >= app_max[0]:
            opt, db = doublons(opt,db)
            opt.pop()
            opt.insert(0,app_max)
            app_max = [app,i]
        else:
            if app >= opt[0][0]:
                opt, db = doublons(opt,db)
                opt.pop()
                opt.insert(0,[app,i])
            else:
                if app >= opt[1][0]:
                    opt, db = doublons(opt,db)
                    opt.pop()
                    opt.insert(1,[app,i])
                else:
                    if app >= opt[2][0]:
                        opt.pop()
                        opt.insert(2,[app,i])
    #On va maintenant calculer les décalges correspondants aux lettres les plus récurrentes.
    #On commence par effacer toutes les informations inutiles de la liste db.
    for j in range(len(db)-1):
        if db[j][0] > db[j+1][0]:
            del db[j+1]
    #On va calculer le décalage le plus probable avec app_max par rapport à l'index de la lettre e.
    a = alph.index(app_max[1])
    if a > 4:
        place = 30-a
    elif a < 4:
        place = 4-a
    S = False
    #Si la première des autres options à la même récurrence que la app_max, on rajoute une option de décalage correspond elle aussi à l'index de e.
    if opt[0][0] == app_max :
        e = opt[0]
        a = alph.index(opt[0][1])
        S = True
        if a > 4:
            place_e = 30-a 
        else:
            place_e = 4-a
    #On calcule ensuite les options de décalage des trois autres options les plus probables.
    #On calcule le décalage pour la première des trois options par rapport au a, par rapport au i pour la deuxième et par rapport au s pour la troisième.
    for i in range(3):
        b = alph.index(opt[i][1])
        if b > l_ind[i]:
            pl.append(26-(b-l_ind[i]))
        else:
            pl.append(26-(l_ind[i]-b))
    #On calcule les options de décalage de la liste des doublons (db).
    for i in range(len(db)):
        b = alph.index(db[i][1])
        if b > l_ind[2]:
            pl.append(26-(b-l_ind[2]))
        else:
            pl.append(26-(l_ind[2]-b))
    y.append(decryptage(x, place))
    if S == True:
        y.append(decryptage(x, place_e))
    for i in range(len(pl)):
        y.append(decryptage(x, pl[i]))
    y="".join(y)
    EntrDec_dec.delete(1.0,END)
    EntrDec_dec.insert("1.0","Propositions les plus pertinentes : \n"+y)
    EntrDec_dec.pack()
    LRien.pack()
    bPossibilités.pack()
    return y
##Création du bouton permettant à l'utilisateur de décoder son texte chiffré
bchiffr_dec=Button(fenetre,text="Craquer",command=pourcentages,font=("Courrier",20),bg="#2c66e9")
def tri(x):
    #La fonction tri est utilisée par la fonction pourcentages. Elle permet de trier la liste contenant les autres options, composée de sous-listes.
    if x[0]< x[1]:
        if x[0]< x[2]:
            a = x.pop(0)
            x.insert(2,a)
            if x[0] < x[1]:
                a = x.pop(0)
                x.insert(1,a)
        else:
            a = x.pop(0)
            x.insert(1,a)
            if x[2]>x[0]:
                a = x.pop(2)
                x.insert(0,a)
    else:
        if x[2]>x[1]:
            a = x.pop(2)
            x.insert(1,a)
    return x

def doublons(x,y):
    #La fonction doublons est utilisée par la fonction pourcentages. Elle permet de tester si une des options qui va être supprimée, a la même récurrence que celle d'avant.
    #Si c'est le cas, on la place dans une nouvelle liste.
    if x[1][0] == x[2][0]:
        y.insert(0,x[2])
    else:
        y = []
    return x, y

def possibilites():
    #La fonction possibilités permet de rendre les résultats du texte chiffré décalé des 26 manières possibles.
    x=EntrTxtCesar_dec.get("1.0","end")
    EntrDec_dec.delete(1.0,END)
    y = []
    for i in range(26):
        y.append(decryptage(x,i))
    y="".join(y)
    EntrDec_dec.insert(1.0,y)
    return y
bPossibilités=Button(fenetre,text="Montrer",command=possibilites,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le déchiffrage du code César et de cacher les éléments inutiles
def decodageCesar():
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack()
    EntrTxtCesar_dec.delete(1.0,END)
    EntrTxtCesar_dec.pack()
    bchiffr_dec.pack()
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()
##Fonction permettant d'afficher des information sur l'histoire du code César, du braille et du morse.
def historique():
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack(pady=70)
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()

##Programme de chiffrement et déchiffrement du morse

##Fonction permettant de chiffrer le code morse
def morse():
    x=EntrMorse.get("1.0","end")
    alph=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9",".",",","?","'","!","/","(",")","&",":",";","=","+","-","_","\"","$","@"]
    alph_m=["·-","-···","-·-·","-··","·","··-·","--·","····","··","·---","-·-","·-··","--","-·","---","·--·","--·-","·-·","···","-","··-","···-","·--","-··-","-·--","--··","·----","··---","···--","····-","·····","-····","--···","---··","----·","-----","·-·-·-","--·--","··--··","·----·","-·-·--","---·","-··-·","-·--·","-·--·-","·-···","---···","-·-·-·","-···-","·-·-·","-····-","··--·-","·-··-·","···-··-","·--·-·"]
    x = list(x)
    b = 0
    x = accents_majs(x)
    #On utlise la fonction accents_majs pour remplacer les majuscules et les lettres accentuées.
    for i in x:
        if i in alph:
            j = alph.index(i)
            x[b] = alph_m[j]+" "
            #On décide de placer un espace entre chaque lettre et deux espaces entre chaque mot.
        b+=1
    x = "".join(x)
    EntrMorseDec.delete(1.0,END)
    EntrMorseDec.insert("1.0",x)
    EntrMorseDec.pack()
    return x
##Création du bouton permettant à l'utilisateur de chiffrer son texte en morse
bchiffrM=Button(fenetre,text="Chiffrer",command=morse,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le chiffrage du morse et de cacher les éléments inutiles
def codageMorse():
    LEntrMorse.pack()
    EntrMorse.delete(1.0,END)
    EntrMorse.pack()
    EntrMorseDec.pack_forget()
    bchiffrM.pack()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()
def decryptage_morse():
    x=EntrMorse_dec.get("1.0","end")
    alph=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9",".",",","?","'","!","/","(",")","&",":",";","=","+","-","_","\"","$","@"]
    alph_m=["·-","-···","-·-·","-··","·","··-·","--·","····","··","·---","-·-","·-··","--","-·","---","·--·","--·-","·-·","···","-","··-","···-","·--","-··-","-·--","--··","·----","··---","···--","····-","·····","-····","--···","---··","----·","-----","·-·-·-","--·--","··--··","·----·","-·-·--","---·","-··-·","-·--·","-·--·-","·-···","---···","-·-·-·","-···-","·-·-·","-····-","··--·-","·-··-·","···-··-","·--·-·"]
    y = list(x)
    y2 = []
    espace = 0
    lettre = ""
    for i in y:
        if i=="·" or i=="-":
            lettre += i
            espace = 0
        #On regroupe les éléments d'une lettre en un seul élément de la liste.
        else:
            y2.append(lettre)
            lettre = ""
            if i==" ":
                for j in range(espace):
                    y2.append(i)
                espace += 1
            else:
                y2.append(i)
                espace = 1
    if lettre != "":
        y2.append(lettre)
    a = 0
    for i in y2:
        if i in alph_m:
            j = alph_m.index(i)
            y2[a] = alph[j]
        a += 1
    y = "".join(y2)
    EntrMorseDec_dec.delete(1.0,END)
    EntrMorseDec_dec.insert("1.0",y)
    EntrMorseDec_dec.pack()
    return y
##Création du bouton permettant à l'utilisateur de déchiffrer son texte en morse
bchiffrM_dec=Button(fenetre,text="Déchiffrer",command=decryptage_morse,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le déchiffrage du morse et de cacher les éléments inutiles
def morse_dec():
    LEntrMorse_dec.pack()
    EntrMorse_dec.delete(1.0,END)
    EntrMorse_dec.pack()
    bchiffrM_dec.pack()
    EntrMorseDec_dec.pack_forget()
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()
##Syntaxe : 1 espace entre chaque lettre, 2 espaces entre chaque mot
##Son :  un point = 1 temps (0.2 s), un trait = 3 temps, 3 temps entre chaque lettre, 7 temps entre chaque mot
##La commande utilisée fait un bip qui est écrasé au bout d'un temps choisi.
def biper():
    texte=EntrBip.get("1.0","end")
    texte=list(texte)
    os.system("sleep O.2s")
    for i,j in enumerate(texte):
        if j=="-":
            ##Pour les traits, on bipe pendant 3 temps et on attend 1 temps
            os.system("(speaker-test -t sine -f 1200 -l 1)& pid=$! ; sleep 0.6s ; kill -9 $pid")
            os.system("sleep O.2s")
        elif j=="·":
            ##Pour les traits, on bipe pendant 1 temps et on attend 1 temps
            os.system("(speaker-test -t sine -f 1200 -l 1)& pid=$! ; sleep 0.2s ; kill -9 $pid")
            os.system("sleep 0.2s")
        elif j==" ":
            ## Silences : on attend 2 temps sauf si il y a deux espaces de suite, cas dans lequel on attend 2 temps de plus 
            os.system("sleep 0.4s")
            if texte[i+1]==" ":
                os.system("sleep 0.4s")
##Création du bouton permettant à l'utilisateur de faire biper l'ordinateur
bbip=Button(fenetre,text="Biper",command=biper,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le bip et de cacher les éléments inutiles
def bip():
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack()
    EntrBip.delete(1.0,END)
    EntrBip.pack()
    bbip.pack()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()

##Programme de chiffrement et déchiffrement du code des rois de France. Le code des rois de France est un code César plus élaboré avec une clef de plusieurs caractères. Le premier caractère du texte
##est chiffré avec le décalage du premier caractère de la clef. Par exemple, si on veut coder "mathurine" avec la clef "abc", le m ne sera pas décalé (décalage de 0 qui corespond à la lettre a), le a
##deviendra un z (décalage de 1 vers la gauche), le t deviendra un r (décalage de 2 vers la gauche). Le h sera codé à nouveau avec le décalage correspondant au a. Ainsi, mathurine deviendra mzrhtpimc.

##Fonction permettant de chiffrer le texte entré par l'utilisateur
def code_des_rois():
    EntrCdeRoisDec.delete(1.0,END)
    x=EntrCdeRois.get("1.0","end")
    clef=EntrClef.get()
    alph = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    ##On convertit le texte et la clef en listes, et on transforme les lettres accentuées en lettres normales (et les majuscules en minuscules) 
    y = list(x)
    y = accents_majs(y)
    clef=list(clef)
    clef=accents_majs(clef)
    b=0
    ##On décale l'alphabet avec la même méthode que dans le code César mais en changeant de décalage à chaque fois
    while b<len(y):
        for j in clef:
            x=ord(j)-ord('a')##Cela nous permet d'associer un numéro à chaque lettre. Par exemple si la lettre est e (101 en ascii), on fait 101-ord('a')=5, et on a donc attribué 5 à e.
            alph2 = decalage(x)
            if b>=len(y): break##On arrête de décaler à la fin du texte, même si on n'a pas lu la clef entière.
            if y[b] in alph:
                k = alph.index(y[b])
                y[b] = alph2[k]
            b+=1
    y="".join(y)
    EntrCdeRoisDec.insert("1.0",y)
    EntrCdeRoisDec.pack()
    return y
##Bouton permettant à l'utilisateur de chiffrer son texte
bchiffrR=Button(fenetre,text="Chiffrer",command=code_des_rois,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le chiffrage du code des rois de France et de cacher les éléments inutiles
def codeRois():
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack()
    EntrCdeRois.delete(1.0,END)
    EntrCdeRois.pack()
    LEntrClef.pack()
    EntrClef.delete(0,END)
    EntrClef.pack()
    bchiffrR.pack()
    EntrCdeRoisDec.delete(1.0,END)
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()
##Fonction permettant de décoder le code des rois de France avec le texte chiffré et la clef
def decodage_code_des_rois():
    EntrCdeRoisDec_dec.delete(1.0,END)
    txt_ch=EntrCdeRois_dec.get("1.0","end")
    clef=EntrClef_dec.get()
    alphabet = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    clef=list(clef)
    texte_dechiffre = list(txt_ch)
    a = 0
    while a<len(txt_ch):
        for j in clef:
            x=ord(j)-ord('a')
            alphabet_deja_chiffre = decalage(x)
            if a>=len(texte_dechiffre): break
            if texte_dechiffre[a] in alphabet:
                k = alphabet_deja_chiffre.index(texte_dechiffre[a])
                texte_dechiffre[a] = alphabet[k]
            a+=1
    texte_dechiffre="".join(texte_dechiffre)
    EntrCdeRoisDec_dec.insert("1.0",texte_dechiffre)
    EntrCdeRoisDec_dec.pack()
    return texte_dechiffre
##Bouton permettant à l'utilisateur de déchiffrer son texte chiffré
bchiffrR_dec=Button(fenetre,text="Déchiffrer",command=decodage_code_des_rois,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le déchiffrage du code des rois de France et de cacher les éléments inutiles
def codeRois_dec():
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack()
    EntrCdeRois_dec.delete(1.0,END)
    EntrCdeRois_dec.pack()
    LEntrClef_dec.pack()
    EntrClef_dec.delete(0,END)
    EntrClef_dec.pack()
    bchiffrR_dec.pack()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    bchiffrBraille.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()

def braille():
    alph=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9","'",",",";",":",".","!","?","-","(",")","\""]
    alph_b=["⠁","⠃","⠉","⠙","⠑","⠋","⠛","⠓","⠊","⠚","⠅","⠇","⠍","⠝","⠕","⠏","⠟","⠗","⠎","⠞","⠥","⠧","⠺","⠭","⠽","⠵","⠼","⠡","⠣","⠩","⠹","⠱","⠫","⠻","⠳","⠪","⠄","⠂","⠆","⠒","⠲","⠖","⠢","⠤","⠦","⠴","⠶"]
    x=EntrBraille.get("1.0","end")
    x = list(x)
    a = 0
    x = accents_majs(x)
    #Le fonctionnement de cette fonction est similaire à celle du morse.
    for i in x:
        if i in alph:
            j = alph.index(i)
            x[a] = alph_b[j]
        a+=1
    x = "".join(x)
    EntrBrailleCode.delete(1.0,END)
    EntrBrailleCode.insert("1.0",x)
    EntrBrailleCode.pack()
    return x
bchiffrBraille=Button(fenetre,text="Chiffrer",command=braille,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le chiffrage du braille et de cacher les éléments inutiles
def codage_braille():
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack()
    EntrBraille.delete(1.0,END)
    EntrBraille.pack()
    bchiffrBraille.pack()
    EntrBrailleCode.delete(1.0,END)
    EntrBrailleCode.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()
def decryptage_braille():
    alph=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9","'",",",";",":",".","!","?","-","(",")","\""]
    alph_b=["⠁","⠃","⠉","⠙","⠑","⠋","⠛","⠓","⠊","⠚","⠅","⠇","⠍","⠝","⠕","⠏","⠟","⠗","⠎","⠞","⠥","⠧","⠺","⠭","⠽","⠵","⠼","⠡","⠣","⠩","⠹","⠱","⠫","⠻","⠳","⠪","⠄","⠂","⠆","⠒","⠲","⠖","⠢","⠤","⠦","⠴","⠶"]
    x=EntrBraille_dec.get("1.0","end")
    x = list(x)
    a = 0
    #Cette fonction est similaire à celle du décryptage du morse.
    for i in x:
        if i in alph_b:
            j = alph_b.index(i)
            x[a] = alph[j]
        a+=1
    x = "".join(x)
    EntrBrailleCode_dec.delete(1.0,END)
    EntrBrailleCode_dec.insert("1.0",x)
    EntrBrailleCode_dec.pack()
    return x

bchiffrBraille_dec=Button(fenetre,text="Déchiffrer",command=decryptage_braille,font=("Courrier",20),bg="#2c66e9")
##Fonction permettant d'afficher les éléments utiles pour le déchiffrage du braille et de cacher les éléments inutiles
def braille_dec():
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    bchiffrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    LEntrBraille_dec.pack()
    EntrBraille_dec.delete(1.0,END)
    EntrBraille_dec.pack()
    bchiffrBraille_dec.pack()
    EntrBrailleCode_dec.delete(1.0,END)
    EntrBrailleCode_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()

##Pour voir comment fonctionne le code lapin, voir le compte rendu 
def code_lapin():
    alph=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","x","y","z"]
    alph_l=["LL","LA","LP","LI","LN","AL","AA","AP","AI","AN","PL","PA","PP","PI","PN","IL","IA","IP","II","IN","NL","NA","NP","NI","NN"]
    x=EntrLapin.get("1.0","end")
    x = list(x)
    a = 0
    x = accents_majs(x)
    #Fonctionne comme le braille
    for i in x:
        if i in alph:
            j = alph.index(i)
            x[a] = alph_l[j]
        a+=1
    x = "".join(x)
    EntrLapinCode.delete(1.0,END)
    EntrLapinCode.insert("1.0",x)
    EntrLapinCode.pack()
    return x

bchiffrLapin=Button(fenetre,text="Chiffrer",command=code_lapin,font=("Courrier",20),bg="#2c66e9")

def lapin():
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    bchiffrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack()
    EntrLapin.delete(1.0,END)
    EntrLapin.pack()
    EntrLapinCode.delete(1.0,END)
    bchiffrLapin.pack()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack_forget()
    EntrLapin_dec.pack_forget()
    EntrLapinCode_dec.pack_forget()
    bchiffrLapin_dec.pack_forget()
def decryptage_lapin():
    x=EntrLapin_dec.get("1.0","end")
    alph=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","x","y","z"]
    alph_l=["LL","LA","LP","LI","LN","AL","AA","AP","AI","AN","PL","PA","PP","PI","PN","IL","IA","IP","II","IN","NL","NA","NP","NI","NN"]
    alph_maj=["L","A","P","I","N"]
    x = list(x)
    x2 = []
    lettre = ""
    for i in x:
        if i in alph_maj:
            if len(lettre) < 2:
                lettre += i
            #On regroupe deux par deux les lettres.
            else :
                x2.append(lettre)
                lettre = ""
                lettre += i
        else:
            x2.append(lettre)
            lettre = ""
            x2.append(i)
    if lettre != "":
        x2.append(lettre)
    a = 0
    for i in x2:
        if i in alph_l:
            j = alph_l.index(i)
            x2[a] = alph[j]
        a += 1
    x = "".join(x2)
    EntrLapinCode_dec.delete(1.0,END)
    EntrLapinCode_dec.insert("1.0",x)
    EntrLapinCode_dec.pack()
    return x
bchiffrLapin_dec=Button(fenetre,text="Déchiffrer",command=decryptage_lapin,font=("Courrier",20),bg="#2c66e9")
def lapin_dec():
    LEntrMorse.pack_forget()
    EntrMorse.pack_forget()
    EntrMorseDec.pack_forget()
    bchiffrM.pack_forget()
    LEntrTxtCesar.pack_forget()
    EntrTxtCesar.pack_forget()
    LEntrDec.pack_forget()
    EntrDec.pack_forget()
    EntrDec_dec.pack_forget()
    bchiffr.pack_forget()
    txtch.pack_forget()
    montr_alphach.pack_forget()
    m_a.pack_forget()
    LEntrTxtCesar_dec.pack_forget()
    EntrTxtCesar_dec.pack_forget()
    bchiffr_dec.pack_forget()
    LEntrCdeRois.pack_forget()
    EntrCdeRois.pack_forget()
    LEntrClef.pack_forget()
    EntrClef.pack_forget()
    bchiffrR.pack_forget()
    EntrCdeRoisDec.pack_forget()
    LEntrCdeRois_dec.pack_forget()
    EntrCdeRois_dec.pack_forget()
    LEntrClef_dec.pack_forget()
    EntrClef_dec.pack_forget()
    bchiffrR_dec.pack_forget()
    EntrCdeRoisDec_dec.pack_forget()
    canvasJC.pack_forget()
    LEntrMorse_dec.pack_forget()
    EntrMorse_dec.pack_forget()
    bchiffrM_dec.pack_forget()
    EntrMorseDec_dec.pack_forget()
    LBienvenue.pack_forget()
    LPays.pack_forget()
    LChiffr.pack_forget()
    LEntrBraille.pack_forget()
    EntrBraille.pack_forget()
    bchiffrBraille.pack_forget()
    EntrBrailleCode.pack_forget()
    LEntrBraille_dec.pack_forget()
    EntrBraille_dec.pack_forget()
    bchiffrBraille_dec.pack_forget()
    EntrBrailleCode_dec.pack_forget()
    LEntrBip.pack_forget()
    EntrBip.pack_forget()
    bbip.pack_forget()
    LRien.pack_forget()
    bPossibilités.pack_forget()
    avocat.place_forget()
    Lhistorique.pack_forget()
    LEntrLapin.pack_forget()
    EntrLapin.pack_forget()
    bchiffrLapin.pack_forget()
    EntrLapinCode.pack_forget()
    LEntrLapin_dec.pack()
    EntrLapin_dec.delete(1.0,END)
    EntrLapin_dec.pack()
    bchiffrLapin_dec.pack()
    EntrLapinCode_dec.delete(1.0,END)
    EntrLapinCode_dec.pack_forget()
##Création du menu
fonteMenu=("Courrier",20)
menu1=Menu(fenetre,bg="#2c66e9")
menccesar=Menu(menu1,tearoff=0)
menu1.add_cascade(label="Code César", menu=menccesar,font=fonteMenu)
menccesar.add_command(label="Codage",command=codageCesar,font=fonteMenu)
menccesar.add_command(label="Décodage",command=decodageCesar,font=fonteMenu)
menmorse=Menu(menu1,tearoff=0)
menu1.add_cascade(label="Morse",menu=menmorse,font=fonteMenu)
menmorse.add_command(label="Codage",command=codageMorse,font=fonteMenu)
menmorse.add_command(label="Décodage",command=morse_dec,font=fonteMenu)
menmorse.add_command(label="Bip",command=bip,font=fonteMenu)
mencderois=Menu(menu1,tearoff=0)
menu1.add_cascade(label="Code des rois de France",menu=mencderois,font=fonteMenu)
mencderois.add_command(label="Codage",command=codeRois,font=fonteMenu)
mencderois.add_command(label="Décodage",command=codeRois_dec,font=fonteMenu)
menbraille=Menu(menu1,tearoff=0)
menu1.add_cascade(label="Braille",menu=menbraille,font=fonteMenu)
menbraille.add_command(label="Codage",command=codage_braille,font=fonteMenu)
menbraille.add_command(label="Décodage",command=braille_dec,font=fonteMenu)
menlapin=Menu(menu1,tearoff=0)
menu1.add_cascade(label="Code Lapin",menu=menlapin,font=fonteMenu)
menlapin.add_command(label="Codage",command=lapin,font=fonteMenu)
menlapin.add_command(label="Décodage",command=lapin_dec,font=fonteMenu)
menu1.add_command(label="Un peu d'histoire",command=historique,font=fonteMenu)
menu1.add_command(label="Fermer",background="red",command=fenetre.destroy,font=fonteMenu)
#Le bouton fermer utilisa la commande destroy, qui permet de fermer la fenetre
fenetre.config(menu=menu1)
